unit ChartFX;

{ Conversion log:
  Property TChartFX.Type renamed to Type_: Identifier is a reserved word
  Array property TChartFX.Const renamed to Const_: Identifier is a reserved word }

interface

uses Ole2, OleCtl, Classes, Graphics, OleCtrls;

const

{ PointTypeConstants }

  CHART_NONEMK = 0;
  CHART_RECTMK = 1;
  CHART_CIRCLEMK = 2;
  CHART_TRIANGLEMK = 3;
  CHART_MARBLEMK = 4;
  CHART_CUBEMK = 5;
  CHART_MANYMK = 6;

{ SchemeConstants }

  CHART_CSSOLID = 0;
  CHART_CSBWPATTERN = 1;
  CHART_CSPATTERN = 2;

{ StackedConstants }

  CHART_NOSTACKED = 0;
  CHART_STACKED = 1;
  CHART_STACKED100 = 2;

{ GridConstants }

  CHART_NOGRID = 0;
  CHART_HORZGRID = 1;
  CHART_VERTGRID = 2;
  CHART_BOTHGRID = 3;
  CHART_GRIDY2 = 4;

{ GalleryConstants }

  LINES = 1;
  BAR = 2;
  SPLINE = 3;
  MARK = 4;
  PIE = 5;
  AREA = 6;
  PARETO = 7;
  SCATTER = 8;
  HILOW = 9;

{ ConstTypeConstants }

  CC_HIDETEXT = 1;
  CC_HIDE = 2;

{ LegendStyleConstants }

  CL_NOTCLIPPED = 1;
  CL_NOTCHANGECOLOR = 2;
  CL_HIDE = 4;
  CL_HIDEXLEG = 4;
  CL_FORCESERLEG = 8;
  CL_GETLEGEND = 16;
  CL_HIDEYLEG = 32;

{ OpenDataConstants }

  COD_VALUES = 1;
  COD_CONSTANTS = 2;
  COD_COLORS = 3;
  COD_STRIPES = 4;
  COD_INIVALUES = 5;
  COD_XVALUES = 6;
  COD_STATUSITEMS = 7;
  COD_UNKNOWN = -1;
  COD_UNCHANGE = 0;

{ ClickConstants }

  CHART_BALLOONCLK = 0;
  CHART_DIALOGCLK = 1;
  CHART_NONECLK = 2;
  CHART_MENUCLK = 3;

{ DialogConstants }

  CDIALOG_EXPORTFILE = 14;
  CDIALOG_IMPORTFILE = 15;
  CDIALOG_WRITETEMPLATE = 8;
  CDIALOG_READTEMPLATE = 9;
  CDIALOG_PAGESETUP = 4;
  CDIALOG_ABOUT = 11;
  CDIALOG_OPTIONS = 12;
  CDIALOG_EDITTITLES = 35;
  CDIALOG_FONTS = 39;
  CDIALOG_ROTATE = 52;

{ AdmConstants }

  CSA_MIN = 0;
  CSA_MAX = 1;
  CSA_GAP = 2;
  CSA_SCALE = 3;
  CSA_YLEGGAP = 4;
  CSA_PIXXVALUE = 5;
  CSA_XMIN = 6;
  CSA_XMAX = 7;
  CSA_XGAP = 8;
  CSA_LOGBASE = 9;

{ TitleConstants }

  CHART_LEFTTIT = 0;
  CHART_RIGHTTIT = 1;
  CHART_TOPTIT = 2;
  CHART_BOTTOMTIT = 3;

{ FontConstants }

  CHART_LEFTFT = 0;
  CHART_RIGHTFT = 1;
  CHART_TOPFT = 2;
  CHART_BOTTOMFT = 3;
  CHART_XLEGFT = 4;
  CHART_YLEGFT = 5;
  CHART_FIXEDFT = 6;
  CHART_LEGENDFT = 7;

{ ItemConstants }

  CI_HORZGRID = 0;
  CI_VERTGRID = 1;

{ DecimalConstants }

  CD_ALL = 0;
  CD_VALUES = 1;
  CD_YLEG = 2;
  CD_XLEG = 3;

type

  TChartFXLButtonDblClk = procedure(Sender: TObject; var X, Y, nSerie, nPoint, nRes: Smallint) of object;
  TChartFXRButtonDown = procedure(Sender: TObject; var X, Y, nSerie, nPoint, nRes: Smallint) of object;
  TChartFXChangeValue = procedure(Sender: TObject; var dValue: Double; var nSerie, nPoint, nRes: Smallint) of object;
  TChartFXChangeString = procedure(Sender: TObject; var nType, nIndex, nRes: Smallint) of object;
  TChartFXChangeColor = procedure(Sender: TObject; var nType, nIndex, nRes: Smallint) of object;
  TChartFXChangePalette = procedure(Sender: TObject; var nIndex, nRes: Smallint) of object;
  TChartFXChangeFont = procedure(Sender: TObject; var nIndex, nRes: Smallint) of object;
  TChartFXChangePattern = procedure(Sender: TObject; var nType, nIndex, nRes: Smallint) of object;
  TChartFXChangePattPal = procedure(Sender: TObject; var nIndex, nRes: Smallint) of object;
  TChartFXMenu = procedure(Sender: TObject; var wParam, nSerie, nPoint, nRes: Smallint) of object;
  TChartFXChangeType = procedure(Sender: TObject; var nType, nRes: Smallint) of object;
  TChartFXUserScroll = procedure(Sender: TObject; wScrollMsg, wScrollParam: Integer; var nRes: Smallint) of object;
  TChartFXGetLegend = procedure(Sender: TObject; nType: Smallint; var nRes: Smallint) of object;

  TChartFX = class(TOleControl)
  private
    FOnLButtonDblClk: TChartFXLButtonDblClk;
    FOnRButtonDown: TChartFXRButtonDown;
    FOnChangeValue: TChartFXChangeValue;
    FOnChangeString: TChartFXChangeString;
    FOnChangeColor: TChartFXChangeColor;
    FOnDestroy: TNotifyEvent;
    FOnReadFile: TNotifyEvent;
    FOnChangePalette: TChartFXChangePalette;
    FOnChangeFont: TChartFXChangeFont;
    FOnReadTemplate: TNotifyEvent;
    FOnChangePattern: TChartFXChangePattern;
    FOnChangePattPal: TChartFXChangePattPal;
    FOnMenu: TChartFXMenu;
    FOnChangeType: TChartFXChangeType;
    FOnUserScroll: TChartFXUserScroll;
    FOnGetLegend: TChartFXGetLegend;
    function Get_Value(index: Smallint): Double; stdcall;
    procedure Set_Value(index: Smallint; Value: Double); stdcall;
    function Get_XValue(index: Smallint): Double; stdcall;
    procedure Set_XValue(index: Smallint; Value: Double); stdcall;
    function Get_IniValue(index: Smallint): Double; stdcall;
    procedure Set_IniValue(index: Smallint; Value: Double); stdcall;
    function Get_Const_(index: Smallint): Double; stdcall;
    procedure Set_Const_(index: Smallint; Value: Double); stdcall;
    function Get_Color(index: Smallint): TColor; stdcall;
    procedure Set_Color(index: Smallint; Value: TColor); stdcall;
    function Get_BkColor(index: Smallint): TColor; stdcall;
    procedure Set_BkColor(index: Smallint; Value: TColor); stdcall;
    function Get_Adm(index: Smallint): Double; stdcall;
    procedure Set_Adm(index: Smallint; Value: Double); stdcall;
    function Get_Pattern(index: Smallint): Smallint; stdcall;
    procedure Set_Pattern(index: Smallint; Value: Smallint); stdcall;
    function Get_Fonts(index: Smallint): Integer; stdcall;
    procedure Set_Fonts(index: Smallint; Value: Integer); stdcall;
    function Get_Title(index: Smallint): string; stdcall;
    procedure Set_Title(index: Smallint; const Value: string); stdcall;
    function Get_Legend(index: Smallint): string; stdcall;
    procedure Set_Legend(index: Smallint; const Value: string); stdcall;
    function Get_SerLeg(index: Smallint): string; stdcall;
    procedure Set_SerLeg(index: Smallint; const Value: string); stdcall;
    function Get_KeyLeg(index: Smallint): string; stdcall;
    procedure Set_KeyLeg(index: Smallint; const Value: string); stdcall;
    function Get_FixLeg(index: Smallint): string; stdcall;
    procedure Set_FixLeg(index: Smallint; const Value: string); stdcall;
    function Get_YLeg(index: Smallint): string; stdcall;
    procedure Set_YLeg(index: Smallint; const Value: string); stdcall;
    function Get_KeySer(index: Smallint): string; stdcall;
    procedure Set_KeySer(index: Smallint; const Value: string); stdcall;
    function Get_StatusText(index: Smallint): string; stdcall;
    procedure Set_StatusText(index: Smallint; const Value: string); stdcall;
    function Get_RGBFont(index: Smallint): TColor; stdcall;
    procedure Set_RGBFont(index: Smallint; Value: TColor); stdcall;
    function Get_HFont(index: Smallint): Smallint; stdcall;
    procedure Set_HFont(index: Smallint; Value: Smallint); stdcall;
    function Get_ItemWidth(index: Smallint): Smallint; stdcall;
    procedure Set_ItemWidth(index: Smallint; Value: Smallint); stdcall;
    function Get_ItemStyle(index: Smallint): Smallint; stdcall;
    procedure Set_ItemStyle(index: Smallint; Value: Smallint); stdcall;
    function Get_ItemColor(index: Smallint): TColor; stdcall;
    procedure Set_ItemColor(index: Smallint; Value: TColor); stdcall;
    function Get_DecimalsNum(index: Smallint): Smallint; stdcall;
    procedure Set_DecimalsNum(index: Smallint; Value: Smallint); stdcall;
  protected
    procedure InitControlData; override;
  public
    function OpenDataEx(nType: Smallint; n1, n2: Integer): Integer; stdcall;
    function CloseData(nType: Smallint): TOleBool; stdcall;
    function DblClk(nType: Smallint; lExtra: Integer): Integer; stdcall;
    function RigClk(nType: Smallint; lExtra: Integer): Integer; stdcall;
    function Status(nItems: Smallint; lpStatus: Integer): Integer; stdcall;
    function ShowDialog(nDialog: Smallint; lExtra: Integer): Integer; stdcall;
    function PrintIt: Integer; stdcall;
    function Scroll(wParam, lParam: Integer): Integer; stdcall;
    function SetStatusItem(index: Smallint; bText: TOleBool; nID: Smallint; bFrame: TOleBool; nWidth, nMin, nDesp: Smallint; dwStyle: Integer): Integer; stdcall;
    function Paint(hDC: Integer; nLeft, nTop, nRight, nBottom, wAction: Smallint; lps: Integer): Integer; stdcall;
    function SetStripe(index: Smallint; dMin, dMax: Double; rgb: TColor): Integer; stdcall;
    function Language(const sResource: string): Integer; stdcall;
    function ExportFile(const lpszNewValue: string): Integer; stdcall;
    function ImportFile(const lpszNewValue: string): Integer; stdcall;
    function WriteTemplate(const lpszNewValue: string): Integer; stdcall;
    function ReadTemplate(const lpszNewValue: string): Integer; stdcall;
    function CopyData: Integer; stdcall;
    function CopyBitmap: Integer; stdcall;
    procedure Refresh; stdcall;
    procedure AboutBox; stdcall;
    property Value[index: Smallint]: Double read Get_Value write Set_Value;
    property XValue[index: Smallint]: Double read Get_XValue write Set_XValue;
    property IniValue[index: Smallint]: Double read Get_IniValue write Set_IniValue;
    property Const_[index: Smallint]: Double read Get_Const_ write Set_Const_;
    property Color[index: Smallint]: TColor read Get_Color write Set_Color;
    property BkColor[index: Smallint]: TColor read Get_BkColor write Set_BkColor;
    property Adm[index: Smallint]: Double read Get_Adm write Set_Adm;
    property Pattern[index: Smallint]: Smallint read Get_Pattern write Set_Pattern;
    property Fonts[index: Smallint]: Integer read Get_Fonts write Set_Fonts;
    property Title[index: Smallint]: string read Get_Title write Set_Title;
    property Legend[index: Smallint]: string read Get_Legend write Set_Legend;
    property SerLeg[index: Smallint]: string read Get_SerLeg write Set_SerLeg;
    property KeyLeg[index: Smallint]: string read Get_KeyLeg write Set_KeyLeg;
    property FixLeg[index: Smallint]: string read Get_FixLeg write Set_FixLeg;
    property YLeg[index: Smallint]: string read Get_YLeg write Set_YLeg;
    property KeySer[index: Smallint]: string read Get_KeySer write Set_KeySer;
    property StatusText[index: Smallint]: string read Get_StatusText write Set_StatusText;
    property RGBFont[index: Smallint]: TColor read Get_RGBFont write Set_RGBFont;
    property HFont[index: Smallint]: Smallint read Get_HFont write Set_HFont;
    property ItemWidth[index: Smallint]: Smallint read Get_ItemWidth write Set_ItemWidth;
    property ItemStyle[index: Smallint]: Smallint read Get_ItemStyle write Set_ItemStyle;
    property ItemColor[index: Smallint]: TColor read Get_ItemColor write Set_ItemColor;
    property DecimalsNum[index: Smallint]: Smallint read Get_DecimalsNum write Set_DecimalsNum;
  published
    property TabStop;
    property DragCursor;
    property DragMode;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property Visible;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnStartDrag;
    property DesignDraw: Smallint index 4 read GetSmallintProp write SetSmallintProp stored False;
    property ThisSerie: Smallint index 1 read GetSmallintProp write SetSmallintProp stored False;
    property ThisPoint: Smallint index 2 read GetSmallintProp write SetSmallintProp stored False;
    property AutoInvalidate: TOleBool index 3 read GetOleBoolProp write SetOleBoolProp stored False;
    property Type_: Integer index 5 read GetIntegerProp write SetIntegerProp stored False;
    property Style: Integer index 6 read GetIntegerProp write SetIntegerProp stored False;
    property NSeries: Smallint index 7 read GetSmallintProp write SetSmallintProp stored False;
    property NValues: Smallint index 8 read GetSmallintProp write SetSmallintProp stored False;
    property ThisColor: TColor index 9 read GetColorProp write SetColorProp stored False;
    property ThisBkColor: TColor index 10 read GetColorProp write SetColorProp stored False;
    property LeftGap: Smallint index 11 read GetSmallintProp write SetSmallintProp stored False;
    property RightGap: Smallint index 12 read GetSmallintProp write SetSmallintProp stored False;
    property TopGap: Smallint index 13 read GetSmallintProp write SetSmallintProp stored False;
    property BottomGap: Smallint index 14 read GetSmallintProp write SetSmallintProp stored False;
    property Decimals: Smallint index 15 read GetSmallintProp write SetSmallintProp stored False;
    property PointType: Smallint index 16 read GetSmallintProp write SetSmallintProp stored False;
    property Scheme: Smallint index 17 read GetSmallintProp write SetSmallintProp stored False;
    property Stacked: Smallint index 18 read GetSmallintProp write SetSmallintProp stored False;
    property Grid: Smallint index 19 read GetSmallintProp write SetSmallintProp stored False;
    property WallWidth: Smallint index 20 read GetSmallintProp write SetSmallintProp stored False;
    property BarHorzGap: Smallint index 21 read GetSmallintProp write SetSmallintProp stored False;
    property View3D: TOleBool index 22 read GetOleBoolProp write SetOleBoolProp stored False;
    property Angles3D: Integer index 23 read GetIntegerProp write SetIntegerProp stored False;
    property PixFactor: Smallint index 24 read GetSmallintProp write SetSmallintProp stored False;
    property LineWidth: Smallint index 25 read GetSmallintProp write SetSmallintProp stored False;
    property LineStyle: Smallint index 26 read GetSmallintProp write SetSmallintProp stored False;
    property LineColor: TColor index 27 read GetColorProp write SetColorProp stored False;
    property LineBkColor: TColor index 28 read GetColorProp write SetColorProp stored False;
    property FixedWidth: Smallint index 29 read GetSmallintProp write SetSmallintProp stored False;
    property FixedStyle: Smallint index 30 read GetSmallintProp write SetSmallintProp stored False;
    property FixedColor: TColor index 31 read GetColorProp write SetColorProp stored False;
    property FixedBkColor: TColor index 32 read GetColorProp write SetColorProp stored False;
    property FixedGap: Smallint index 33 read GetSmallintProp write SetSmallintProp stored False;
    property RGBBarHorz: TColor index 34 read GetColorProp write SetColorProp stored False;
    property RGBBk: TColor index 35 read GetColorProp write SetColorProp stored False;
    property RGB2DBk: TColor index 36 read GetColorProp write SetColorProp stored False;
    property RGB3DBk: TColor index 37 read GetColorProp write SetColorProp stored False;
    property ShowStatus: TOleBool index 38 read GetOleBoolProp write SetOleBoolProp stored False;
    property HText: string index 39 read GetStringProp write SetStringProp stored False;
    property ChartStatus: Smallint index 40 read GetSmallintProp write SetSmallintProp stored False;
    property Edit: Smallint index 41 read GetSmallintProp write SetSmallintProp stored False;
    property ChartType: Smallint index 42 read GetSmallintProp write SetSmallintProp stored False;
    property Chart3D: TOleBool index 43 read GetOleBoolProp write SetOleBoolProp stored False;
    property ToolBar: TOleBool index 44 read GetOleBoolProp write SetOleBoolProp stored False;
    property PaletteBar: TOleBool index 45 read GetOleBoolProp write SetOleBoolProp stored False;
    property PatternBar: TOleBool index 46 read GetOleBoolProp write SetOleBoolProp stored False;
    property CustTool: Integer index 47 read GetIntegerProp write SetIntegerProp stored False;
    property ReturnValue: Integer index 48 read GetIntegerProp write SetIntegerProp stored False;
    property AutoIncrement: TOleBool index 49 read GetOleBoolProp write SetOleBoolProp stored False;
    property ThisValue: Double index 50 read GetDoubleProp write SetDoubleProp stored False;
    property VertGridGap: Smallint index 51 read GetSmallintProp write SetSmallintProp stored False;
    property XLegType: Smallint index 52 read GetSmallintProp write SetSmallintProp stored False;
    property ConstType: Smallint index 53 read GetSmallintProp write SetSmallintProp stored False;
    property LeftFont: Variant index 54 read GetVariantProp write SetVariantProp stored False;
    property RightFont: Variant index 55 read GetVariantProp write SetVariantProp stored False;
    property TopFont: Variant index 56 read GetVariantProp write SetVariantProp stored False;
    property BottomFont: Variant index 57 read GetVariantProp write SetVariantProp stored False;
    property XLegFont: Variant index 58 read GetVariantProp write SetVariantProp stored False;
    property YLegFont: Variant index 59 read GetVariantProp write SetVariantProp stored False;
    property FixedFont: Variant index 60 read GetVariantProp write SetVariantProp stored False;
    property LegendFont: Variant index 61 read GetVariantProp write SetVariantProp stored False;
    property LegendWidth: Smallint index 62 read GetSmallintProp write SetSmallintProp stored False;
    property Enabled: TOleBool index -514 read GetOleBoolProp write SetOleBoolProp stored False;
    property hWnd: Integer index -515 read GetIntegerProp write SetIntegerProp stored False;
    property BorderStyle: Smallint index -504 read GetSmallintProp write SetSmallintProp stored False;
    property hCtlWnd: Integer index 63 read GetIntegerProp write SetIntegerProp stored False;
    property OnLButtonDblClk: TChartFXLButtonDblClk read FOnLButtonDblClk write FOnLButtonDblClk;
    property OnRButtonDown: TChartFXRButtonDown read FOnRButtonDown write FOnRButtonDown;
    property OnChangeValue: TChartFXChangeValue read FOnChangeValue write FOnChangeValue;
    property OnChangeString: TChartFXChangeString read FOnChangeString write FOnChangeString;
    property OnChangeColor: TChartFXChangeColor read FOnChangeColor write FOnChangeColor;
    property OnDestroy: TNotifyEvent read FOnDestroy write FOnDestroy;
    property OnReadFile: TNotifyEvent read FOnReadFile write FOnReadFile;
    property OnChangePalette: TChartFXChangePalette read FOnChangePalette write FOnChangePalette;
    property OnChangeFont: TChartFXChangeFont read FOnChangeFont write FOnChangeFont;
    property OnReadTemplate: TNotifyEvent read FOnReadTemplate write FOnReadTemplate;
    property OnChangePattern: TChartFXChangePattern read FOnChangePattern write FOnChangePattern;
    property OnChangePattPal: TChartFXChangePattPal read FOnChangePattPal write FOnChangePattPal;
    property OnMenu: TChartFXMenu read FOnMenu write FOnMenu;
    property OnChangeType: TChartFXChangeType read FOnChangeType write FOnChangeType;
    property OnUserScroll: TChartFXUserScroll read FOnUserScroll write FOnUserScroll;
    property OnGetLegend: TChartFXGetLegend read FOnGetLegend write FOnGetLegend;
  end;

procedure Register;

implementation

{$J+}

procedure TChartFX.InitControlData;
const
  CEventDispIDs: array[0..15] of Integer = (
    $00000001, $00000002, $00000003, $00000004, $00000005, $00000006,
    $00000007, $00000008, $00000009, $0000000A, $0000000B, $0000000C,
    $0000000D, $0000000E, $0000000F, $00000010);
  CLicenseKey: array[0..71] of Word = (
    $0043, $0068, $0061, $0072, $0074, $0020, $0046, $0058, $0020, $0032,
    $002E, $0030, $0020, $004F, $0043, $0058, $0033, $0032, $0020, $0028,
    $0033, $0032, $0020, $0042, $0069, $0074, $0073, $0029, $002E, $0020,
    $0043, $006F, $0070, $0079, $0072, $0069, $0067, $0068, $0074, $0020,
    $0028, $0063, $0029, $0020, $0031, $0039, $0039, $0034, $0020, $0053,
    $006F, $0066, $0074, $0077, $0061, $0072, $0065, $0020, $0046, $0058,
    $002C, $0020, $0049, $006E, $0063, $002E, $002D, $0031, $0039, $0039,
    $0035, $0000);
  CControlData: TControlData = (
    ClassID: (
      D1:$8996B0A1;D2:$D7BE;D3:$101B;D4:($86,$50,$00,$AA,$00,$3A,$55,$93));
    EventIID: (
      D1:$2DC488B1;D2:$D891;D3:$101B;D4:($86,$52,$00,$AA,$00,$3A,$55,$93));
    EventCount: 16;
    EventDispIDs: @CEventDispIDs;
    LicenseKey: @CLicenseKey;
    Flags: $00000008);
begin
  ControlData := @CControlData;
end;

function TChartFX.OpenDataEx;
const
  DispInfo: array[0..10] of Byte = ($40,$00,$00,$00,$03,$01,$03,$00,$02,$03,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TChartFX.CloseData;
const
  DispInfo: array[0..8] of Byte = ($41,$00,$00,$00,$0B,$01,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TChartFX.DblClk;
const
  DispInfo: array[0..9] of Byte = ($42,$00,$00,$00,$03,$01,$02,$00,$02,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TChartFX.RigClk;
const
  DispInfo: array[0..9] of Byte = ($43,$00,$00,$00,$03,$01,$02,$00,$02,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TChartFX.Status;
const
  DispInfo: array[0..9] of Byte = ($44,$00,$00,$00,$03,$01,$02,$00,$02,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TChartFX.ShowDialog;
const
  DispInfo: array[0..9] of Byte = ($45,$00,$00,$00,$03,$01,$02,$00,$02,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TChartFX.PrintIt;
const
  DispInfo: array[0..7] of Byte = ($46,$00,$00,$00,$03,$01,$00,$00);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TChartFX.Scroll;
const
  DispInfo: array[0..9] of Byte = ($47,$00,$00,$00,$03,$01,$02,$00,$03,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TChartFX.SetStatusItem;
const
  DispInfo: array[0..15] of Byte = ($48,$00,$00,$00,$03,$01,$08,$00,$02,$0B,$02,$0B,$02,$02,$02,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TChartFX.Paint;
const
  DispInfo: array[0..14] of Byte = ($49,$00,$00,$00,$03,$01,$07,$00,$03,$02,$02,$02,$02,$02,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TChartFX.SetStripe;
const
  DispInfo: array[0..11] of Byte = ($4A,$00,$00,$00,$03,$01,$04,$00,$02,$05,$05,$03);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TChartFX.Language;
const
  DispInfo: array[0..8] of Byte = ($4B,$00,$00,$00,$03,$01,$01,$00,$08);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TChartFX.ExportFile;
const
  DispInfo: array[0..8] of Byte = ($4C,$00,$00,$00,$03,$01,$01,$00,$08);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TChartFX.ImportFile;
const
  DispInfo: array[0..8] of Byte = ($4D,$00,$00,$00,$03,$01,$01,$00,$08);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TChartFX.WriteTemplate;
const
  DispInfo: array[0..8] of Byte = ($4E,$00,$00,$00,$03,$01,$01,$00,$08);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TChartFX.ReadTemplate;
const
  DispInfo: array[0..8] of Byte = ($4F,$00,$00,$00,$03,$01,$01,$00,$08);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TChartFX.CopyData;
const
  DispInfo: array[0..7] of Byte = ($50,$00,$00,$00,$03,$01,$00,$00);
begin
  InvokeMethod(DispInfo, @Result);
end;

function TChartFX.CopyBitmap;
const
  DispInfo: array[0..7] of Byte = ($51,$00,$00,$00,$03,$01,$00,$00);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TChartFX.Refresh;
const
  DispInfo: array[0..7] of Byte = ($DA,$FD,$FF,$FF,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure TChartFX.AboutBox;
const
  DispInfo: array[0..7] of Byte = ($D8,$FD,$FF,$FF,$00,$01,$00,$00);
begin
  InvokeMethod(DispInfo, nil);
end;

function TChartFX.Get_Value;
const
  DispInfo: array[0..8] of Byte = ($52,$00,$00,$00,$05,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TChartFX.Set_Value;
const
  DispInfo: array[0..9] of Byte = ($52,$00,$00,$00,$00,$04,$02,$00,$02,$05);
begin
  InvokeMethod(DispInfo, nil);
end;

function TChartFX.Get_XValue;
const
  DispInfo: array[0..8] of Byte = ($53,$00,$00,$00,$05,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TChartFX.Set_XValue;
const
  DispInfo: array[0..9] of Byte = ($53,$00,$00,$00,$00,$04,$02,$00,$02,$05);
begin
  InvokeMethod(DispInfo, nil);
end;

function TChartFX.Get_IniValue;
const
  DispInfo: array[0..8] of Byte = ($54,$00,$00,$00,$05,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TChartFX.Set_IniValue;
const
  DispInfo: array[0..9] of Byte = ($54,$00,$00,$00,$00,$04,$02,$00,$02,$05);
begin
  InvokeMethod(DispInfo, nil);
end;

function TChartFX.Get_Const_;
const
  DispInfo: array[0..8] of Byte = ($55,$00,$00,$00,$05,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TChartFX.Set_Const_;
const
  DispInfo: array[0..9] of Byte = ($55,$00,$00,$00,$00,$04,$02,$00,$02,$05);
begin
  InvokeMethod(DispInfo, nil);
end;

function TChartFX.Get_Color;
const
  DispInfo: array[0..8] of Byte = ($56,$00,$00,$00,$03,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TChartFX.Set_Color;
const
  DispInfo: array[0..9] of Byte = ($56,$00,$00,$00,$00,$04,$02,$00,$02,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

function TChartFX.Get_BkColor;
const
  DispInfo: array[0..8] of Byte = ($57,$00,$00,$00,$03,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TChartFX.Set_BkColor;
const
  DispInfo: array[0..9] of Byte = ($57,$00,$00,$00,$00,$04,$02,$00,$02,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

function TChartFX.Get_Adm;
const
  DispInfo: array[0..8] of Byte = ($58,$00,$00,$00,$05,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TChartFX.Set_Adm;
const
  DispInfo: array[0..9] of Byte = ($58,$00,$00,$00,$00,$04,$02,$00,$02,$05);
begin
  InvokeMethod(DispInfo, nil);
end;

function TChartFX.Get_Pattern;
const
  DispInfo: array[0..8] of Byte = ($59,$00,$00,$00,$02,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TChartFX.Set_Pattern;
const
  DispInfo: array[0..9] of Byte = ($59,$00,$00,$00,$00,$04,$02,$00,$02,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

function TChartFX.Get_Fonts;
const
  DispInfo: array[0..8] of Byte = ($5A,$00,$00,$00,$03,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TChartFX.Set_Fonts;
const
  DispInfo: array[0..9] of Byte = ($5A,$00,$00,$00,$00,$04,$02,$00,$02,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

function TChartFX.Get_Title;
const
  DispInfo: array[0..8] of Byte = ($5B,$00,$00,$00,$08,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TChartFX.Set_Title;
const
  DispInfo: array[0..9] of Byte = ($5B,$00,$00,$00,$00,$04,$02,$00,$02,$08);
begin
  InvokeMethod(DispInfo, nil);
end;

function TChartFX.Get_Legend;
const
  DispInfo: array[0..8] of Byte = ($5C,$00,$00,$00,$08,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TChartFX.Set_Legend;
const
  DispInfo: array[0..9] of Byte = ($5C,$00,$00,$00,$00,$04,$02,$00,$02,$08);
begin
  InvokeMethod(DispInfo, nil);
end;

function TChartFX.Get_SerLeg;
const
  DispInfo: array[0..8] of Byte = ($5D,$00,$00,$00,$08,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TChartFX.Set_SerLeg;
const
  DispInfo: array[0..9] of Byte = ($5D,$00,$00,$00,$00,$04,$02,$00,$02,$08);
begin
  InvokeMethod(DispInfo, nil);
end;

function TChartFX.Get_KeyLeg;
const
  DispInfo: array[0..8] of Byte = ($5E,$00,$00,$00,$08,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TChartFX.Set_KeyLeg;
const
  DispInfo: array[0..9] of Byte = ($5E,$00,$00,$00,$00,$04,$02,$00,$02,$08);
begin
  InvokeMethod(DispInfo, nil);
end;

function TChartFX.Get_FixLeg;
const
  DispInfo: array[0..8] of Byte = ($5F,$00,$00,$00,$08,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TChartFX.Set_FixLeg;
const
  DispInfo: array[0..9] of Byte = ($5F,$00,$00,$00,$00,$04,$02,$00,$02,$08);
begin
  InvokeMethod(DispInfo, nil);
end;

function TChartFX.Get_YLeg;
const
  DispInfo: array[0..8] of Byte = ($60,$00,$00,$00,$08,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TChartFX.Set_YLeg;
const
  DispInfo: array[0..9] of Byte = ($60,$00,$00,$00,$00,$04,$02,$00,$02,$08);
begin
  InvokeMethod(DispInfo, nil);
end;

function TChartFX.Get_KeySer;
const
  DispInfo: array[0..8] of Byte = ($61,$00,$00,$00,$08,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TChartFX.Set_KeySer;
const
  DispInfo: array[0..9] of Byte = ($61,$00,$00,$00,$00,$04,$02,$00,$02,$08);
begin
  InvokeMethod(DispInfo, nil);
end;

function TChartFX.Get_StatusText;
const
  DispInfo: array[0..8] of Byte = ($62,$00,$00,$00,$08,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TChartFX.Set_StatusText;
const
  DispInfo: array[0..9] of Byte = ($62,$00,$00,$00,$00,$04,$02,$00,$02,$08);
begin
  InvokeMethod(DispInfo, nil);
end;

function TChartFX.Get_RGBFont;
const
  DispInfo: array[0..8] of Byte = ($63,$00,$00,$00,$03,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TChartFX.Set_RGBFont;
const
  DispInfo: array[0..9] of Byte = ($63,$00,$00,$00,$00,$04,$02,$00,$02,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

function TChartFX.Get_HFont;
const
  DispInfo: array[0..8] of Byte = ($64,$00,$00,$00,$02,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TChartFX.Set_HFont;
const
  DispInfo: array[0..9] of Byte = ($64,$00,$00,$00,$00,$04,$02,$00,$02,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

function TChartFX.Get_ItemWidth;
const
  DispInfo: array[0..8] of Byte = ($65,$00,$00,$00,$02,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TChartFX.Set_ItemWidth;
const
  DispInfo: array[0..9] of Byte = ($65,$00,$00,$00,$00,$04,$02,$00,$02,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

function TChartFX.Get_ItemStyle;
const
  DispInfo: array[0..8] of Byte = ($66,$00,$00,$00,$02,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TChartFX.Set_ItemStyle;
const
  DispInfo: array[0..9] of Byte = ($66,$00,$00,$00,$00,$04,$02,$00,$02,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

function TChartFX.Get_ItemColor;
const
  DispInfo: array[0..8] of Byte = ($67,$00,$00,$00,$03,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TChartFX.Set_ItemColor;
const
  DispInfo: array[0..9] of Byte = ($67,$00,$00,$00,$00,$04,$02,$00,$02,$03);
begin
  InvokeMethod(DispInfo, nil);
end;

function TChartFX.Get_DecimalsNum;
const
  DispInfo: array[0..8] of Byte = ($68,$00,$00,$00,$02,$02,$01,$00,$02);
begin
  InvokeMethod(DispInfo, @Result);
end;

procedure TChartFX.Set_DecimalsNum;
const
  DispInfo: array[0..9] of Byte = ($68,$00,$00,$00,$00,$04,$02,$00,$02,$02);
begin
  InvokeMethod(DispInfo, nil);
end;

procedure Register;
begin
  RegisterComponents('OCX', [TChartFX]);
end;

end.
